vprocss: xvprocss.c File Reference

| vprocss Xilinx SDK Drivers API Documentation

- Overview
- Data Structures
- APIs
- File List
- Examples

xvprocss.c File Reference

## Overview

This is main code of Xilinx Video Processing Subsystem device driver.

Please see xvprocss.h for more details of the driver.

    MODIFICATION HISTORY:

    Ver   Who    Date     Changes

    1.00  rco  08/28/15   Initial Release
    2.00  rco  11/05/15   Update to adapt to sub-core layer 2 changes
          dmc  12/02/15   Added support for additional topologies
          dmc  12/17/15   Rename and modify H,VCresample constants and routines
                          Modify CSC-only validate and setup routines
                          Modify Scaler-only validate and setup routines
                          Modifications to conform to coding style
          dmc  01/11/16   Write to new Event Log: log status and error events
          dmc  02/17/16   Modify timing and placement of axis and aximm resets
          dmc  02/24/16   Rename some constants and variables
          dmc  03/03/16   Init VideoStream structs to 0 in SetPowerOnDefaultState
    2.10  mpe  04/28/16   Added optional color format conversion handling in
                          scaler only topology
          rco  07/20/16   Replace deprecated MB_Sleep with usleep
                          Maintain user defined PIP color between pipe reset
    2.30  rco  12/15/16   Added HasMADI configuration option check
               02/08/17   Fix C++ compilation warnings
               02/15/17   Fix custom resolution support for 1 PPC configuration
    2.40  vyc  10/04/17   Added support for conversion from 420/422/444/RGB to
                          420/422/444/RGB with CSC-only topology
    2.50  vyc  04/04/18   Fix for HScaler setup with 420 input

## Macros
Reset Network
The following constants define various reset lines in the subsystem
#define | XVPROCSS_RSTMASK_VIDEO_IN (0x01)
| Reset line going out of vpss. More...
#define | XVPROCSS_RSTMASK_IP_AXIS (0x02)
| Reset line for vpss internal video IP blocks. More...
#define | XVPROCSS_RSTMASK_IP_AXIMM (0x01)
| Reset line for vpss internal AXI-MM blocks. More...

## VDMA Alignment required step size
The following constants define various Zoom/Pip window horizontal step sizes that keeps the VDMA access aligned to aximm interface width, based on Pixels/Clock and Color Depth of the configured subsystem. This is required as current version of VDMA does not support DRE if interface width is >64bits. Software has to align the hsize and stride for all possible configurations supported by the subsystem. Current subsystem version supports the following Number of components = 3 (Fixed) Pixels/Clock = 1, 2, 4 Color Depth = 8, 10, 12, 16 (4 variations)
const u16 | XVprocSs_PixelHStep [3][4]
void | XVprocSs_SetUserTimerHandler (XVprocSs *InstancePtr, XVidC_DelayHandler CallbackFunc, void *CallbackRef)
| This function registers the user defined delay/sleep function with subsystem. More...
void | XVprocSs_SetFrameBufBaseaddr (XVprocSs *InstancePtr, UINTPTR addr)
| This function sets the base address of the video frame buffers used by the subsystem instance. More...
int | XVprocSs_CfgInitialize (XVprocSs *InstancePtr, XVprocSs_Config *CfgPtr, UINTPTR EffectiveAddr)
| This function initializes the video subsystem and included sub-cores. More...
void | XVprocSs_Start (XVprocSs *InstancePtr)
| This function starts the video subsystem including all sub-cores that are included in the processing pipeline for a given use-case. More...
void | XVprocSs_Stop (XVprocSs *InstancePtr)
| This function stops the video subsystem including all sub-cores Stop the video pipe starting from front to back. More...
void | XVprocSs_Reset (XVprocSs *InstancePtr)
| This function resets the video subsystem sub-cores. More...
int | XVprocSs_SetVidStreamIn (XVprocSs *InstancePtr, const XVidC_VideoStream *StrmIn)
| This function configures the video subsystem input interface. More...
int | XVprocSs_SetVidStreamOut (XVprocSs *InstancePtr, const XVidC_VideoStream *StrmOut)
| This function configures the video subsystem output interface. More...
int | XVprocSs_SetStreamResolution (XVidC_VideoStream *StreamPtr, const XVidC_VideoMode VmId, XVidC_VideoTiming const *Timing)
| This function sets the required subsystem video stream to the user provided stream and timing parameters. More...
void | XVprocSs_UpdateZoomPipWindow (XVprocSs *InstancePtr)
| This function updates the Pip/Zoom window currently on screen in-place. More...
void | XVprocSs_SetZoomPipWindow (XVprocSs *InstancePtr, XVprocSs_Win mode, XVidC_VideoWindow *win)
| This function allows user to set the Zoom or PIP window. More...
void | XVprocSs_GetZoomPipWindow (XVprocSs *InstancePtr, XVprocSs_Win mode, XVidC_VideoWindow *win)
| This function reads the user defined Zoom/Pip window from scratch pad memory. More...
void | XVprocSs_SetZoomMode (XVprocSs *InstancePtr, u8 OnOff)
| This function configures the video subsystem to enable/disable ZOOM feature If ZOOM mode is set to ON but user has not set window coordinates then quarter of input stream resolution at coordinates 0,0 is set as the default zoom window. More...
void | XVprocSs_SetPipMode (XVprocSs *InstancePtr, u8 OnOff)
| This function configures the video subsystem to enable/disable PIP feature If PIP mode is set to ON but user has not set window coordinates then half of input stream resolution at coordinates 0,0 is set as the default zoom window. More...
int | XVprocSs_SetSubsystemConfig (XVprocSs *InstancePtr)
| This function is the entry point into the video processing subsystem driver processing path. More...
s32 | XVprocSs_GetPictureBrightness (XVprocSs *InstancePtr)
| This function returns picture brighntess setting. More...
void | XVprocSs_SetPictureBrightness (XVprocSs *InstancePtr, s32 NewValue)
| This function updates picture brighntess setting with specified value. More...
s32 | XVprocSs_GetPictureContrast (XVprocSs *InstancePtr)
| This function returns picture contrast setting. More...
void | XVprocSs_SetPictureContrast (XVprocSs *InstancePtr, s32 NewValue)
| This function updates picture contrast setting with specified value. More...
s32 | XVprocSs_GetPictureSaturation (XVprocSs *InstancePtr)
| This function returns picture saturation setting. More...
void | XVprocSs_SetPictureSaturation (XVprocSs *InstancePtr, s32 NewValue)
| This function updates picture saturation setting with specified value. More...
s32 | XVprocSs_GetPictureGain (XVprocSs *InstancePtr, XVprocSs_ColorChannel ChId)
| This function returns picture gain setting for the specified color channel. More...
void | XVprocSs_SetPictureGain (XVprocSs *InstancePtr, XVprocSs_ColorChannel ChId, s32 NewValue)
| This function updates picture gain setting with specified value. More...
XVidC_ColorStd | XVprocSs_GetPictureColorStdIn (XVprocSs *InstancePtr)
| This function returns picture color standard setting for input. More...
XVidC_ColorStd | XVprocSs_GetPictureColorStdOut (XVprocSs *InstancePtr)
| This function returns picture color standard setting for output. More...
void | XVprocSs_SetPictureColorStdIn (XVprocSs *InstancePtr, XVidC_ColorStd NewVal)
| This function sets picture color standard setting for input. More...
void | XVprocSs_SetPictureColorStdOut (XVprocSs *InstancePtr, XVidC_ColorStd NewVal)
| This function sets picture color standard setting for output. More...
XVidC_ColorRange | XVprocSs_GetPictureColorRange (XVprocSs *InstancePtr)
| This function returns picture color range for output. More...
void | XVprocSs_SetPictureColorRange (XVprocSs *InstancePtr, XVidC_ColorRange NewVal)
| This function sets picture color range for output. More...
int | XVprocSs_SetPictureDemoWindow (XVprocSs *InstancePtr, XVidC_VideoWindow *Win)
| This function sets picture Demo Window. More...
void | XVprocSs_SetPIPBackgroundColor (XVprocSs *InstancePtr, XLboxColorId ColorId)
| This function sets PIP background color. More...
void | XVprocSs_LoadScalerCoeff (XVprocSs *InstancePtr, u32 CoreId, u16 num_phases, u16 num_taps, const short *Coeff)
| This function enables user to load external filter coefficients for Scaler cores, independently for H & V. More...
void | XVprocSs_LoadChromaResamplerCoeff (XVprocSs *InstancePtr, u32 CoreId, u16 num_taps, const short *Coeff)
| This function enables user to load external filter coefficients for Chroma Resampler cores, independently for H & V. More...
void | XVprocSs_ReportSubcoreStatus (XVprocSs *InstancePtr, u32 SubcoreId)
| This function reports the status of specified sub-core. More...
void | XVprocSs_ReportSubsystemCoreInfo (XVprocSs *InstancePtr)
| This function reports Video Processing Subsystem HW configuration. More...
void | XVprocSs_ReportSubsystemConfig (XVprocSs *InstancePtr)
| This function reports the subsystem HW and input/output stream configuration. More...

## Macro Definition Documentation

#define XVPROCSS_RSTMASK_IP_AXIMM (0x01)

Reset line for vpss internal AXI-MM blocks.

Referenced by XVprocSs_Reset().

#define XVPROCSS_RSTMASK_IP_AXIS (0x02)

Reset line for vpss internal video IP blocks.

Referenced by XVprocSs_Reset().

#define XVPROCSS_RSTMASK_VIDEO_IN (0x01)

Reset line going out of vpss.

Referenced by XVprocSs_Start().

## Function Documentation

int XVprocSs_CfgInitialize | ( | XVprocSs * | InstancePtr,
|  | XVprocSs_Config * | CfgPtr,
|  | UINTPTR | EffectiveAddr
| ) |  |

This function initializes the video subsystem and included sub-cores.

This function must be called prior to using the subsystem. Initialization includes setting up the instance data for top level as well as all included sub-core therein, and ensuring the hardware is in a known stable state.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  CfgPtr | points to the configuration structure associated with the subsystem instance.
  EffectiveAddr | is the base address of the device. If address translation is being used, then this parameter must reflect the virtual base address. Otherwise, the physical address should be used.

Returns
  XST_SUCCESS if initialization is successful else XST_FAILURE

References XVprocSs_Config::BaseAddress, XVprocSs_Config::ColorDepth, XVprocSs::Config, XVprocSs::CscPtr, XVprocSs::CtxtData, XVprocSs_ContextData::DeintBufAddr, XVprocSs::DeintPtr, XVprocSs::FrameBufBaseaddr, XVprocSs_Config::HasMADI, XVprocSs::HcrsmplrPtr, XVprocSs::HscalerPtr, XVprocSs::IsReady, XVprocSs::LboxPtr, XVprocSs_Config::MaxHeight, XVprocSs_Config::MaxWidth, XVprocSs_Config::NumVidComponents, XVprocSs::RouterPtr, XVprocSs::RstAximmPtr, XVprocSs::RstAxisPtr, XVprocSs::VcrsmplrInPtr, XVprocSs::VcrsmplrOutPtr, XVprocSs::VdmaPtr, XVprocSs::VscalerPtr, XVPROCSS_EVT_CHK_BASEADDR, XVPROCSS_EVT_CHK_TOPO, XVPROCSS_EVT_INIT, XVprocSs_GetSubsystemTopology, XVprocSs_LogWrite(), XVprocSs_Reset(), XVprocSs_SubcoreInitCsc(), XVprocSs_SubcoreInitDeinterlacer(), XVprocSs_SubcoreInitHCrsmplr(), XVprocSs_SubcoreInitHScaler(), XVprocSs_SubcoreInitLetterbox(), XVprocSs_SubcoreInitResetAximm(), XVprocSs_SubcoreInitResetAxis(), XVprocSs_SubcoreInitRouter(), XVprocSs_SubcoreInitVCrsmpleIn(), XVprocSs_SubcoreInitVCrsmpleOut(), XVprocSs_SubcoreInitVdma(), and XVprocSs_SubcoreInitVScaler().

Referenced by XSys_Init().

s32 XVprocSs_GetPictureBrightness | ( | XVprocSs * | InstancePtr | ) |

This function returns picture brighntess setting.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.

Returns
  current value (0-100), if csc subcore is included

References XVprocSs::CscPtr.

XVidC_ColorRange XVprocSs_GetPictureColorRange | ( | XVprocSs * | InstancePtr | ) |

This function returns picture color range for output.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.

Returns
  Current set output range, if csc core is included
  - XVIDC_CR_16_235
  - XVIDC_CR_16_240

- XVIDC_CR_0_255 Else XVIDC_CR_UNKNOWN_RANGE

References XVprocSs::CscPtr.

XVidC_ColorStd XVprocSs_GetPictureColorStdIn | ( | XVprocSs * | InstancePtr | ) |

This function returns picture color standard setting for input.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.

Returns
  Current set color standard, if csc core is included
  - XVIDC_BT_2020
  - XVIDC_BT_709
  - XVIDC_BT_601 Else XVIDC_BT_UNKNOWN

References XVprocSs::CscPtr.

XVidC_ColorStd XVprocSs_GetPictureColorStdOut | ( | XVprocSs * | InstancePtr | ) |

This function returns picture color standard setting for output.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.

Returns
  Current set color standard, if csc core is included
  - XVIDC_BT_2020
  - XVIDC_BT_709
  - XVIDC_BT_601 Else XVIDC_BT_UNKNOWN

References XVprocSs::CscPtr.

s32 XVprocSs_GetPictureContrast | ( | XVprocSs * | InstancePtr | ) |

This function returns picture contrast setting.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.

Returns
  current value (0-100), if csc subcore is included

References XVprocSs::CscPtr.

s32 XVprocSs_GetPictureGain | ( | XVprocSs * | InstancePtr,
|  | XVprocSs_ColorChannel | ChId
| ) |  |

This function returns picture gain setting for the specified color channel.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  ChId | is the color channel id for which gain is requested

Returns
  current value (0-100), if csc subcore is included

References XVprocSs::CscPtr.

s32 XVprocSs_GetPictureSaturation | ( | XVprocSs * | InstancePtr | ) |

This function returns picture saturation setting.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.

Returns
  current value (0-100), if csc subcore is included

References XVprocSs::CscPtr.

void XVprocSs_GetZoomPipWindow | ( | XVprocSs * | InstancePtr,
|  | XVprocSs_Win | mode,
|  | XVidC_VideoWindow * | win
| ) |  |

This function reads the user defined Zoom/Pip window from scratch pad memory.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  mode | is feature (PIP or ZOOM) whose window coordinates are to be retrieved
  win | is structure that will contain read window coordinates and size

Note
  For Zoom mode RD client window is read from scratch pad memory For Pip mode WR client window is read from scratch pad memory This function is not applicable in Subsystem Stream Mode Configuration

References XVprocSs::CtxtData, XVprocSs_ContextData::RdWindow, XVprocSs_ContextData::WrWindow, XVPROCSS_EDAT_SUCCESS, XVPROCSS_EVT_GET_ZPWIN, XVprocSs_IsConfigModeMax, and XVprocSs_LogWrite().

Referenced by XVprocSs_ReportSubsystemConfig(), XVprocSs_VdmaSetWinToDnScaleMode(), and XVprocSs_VdmaSetWinToUpScaleMode().

void XVprocSs_LoadChromaResamplerCoeff | ( | XVprocSs * | InstancePtr,
|  | u32 | CoreId,
|  | u16 | num_taps,
|  | const short * | Coeff
| ) |  |

This function enables user to load external filter coefficients for Chroma Resampler cores, independently for H & V.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  CoreId | is the resampler core to be worked on XVPROCSS_SUBCORE_CR_H XVPROCSS_SUBCORE_CR_V_IN XVPROCSS_SUBCORE_CR_V_OUT
  num_taps | is the taps of the resampler hw instance
  Coeff | is the pointer to the filter table to be loaded

Returns
  None

Note
  Applicable only if Resampler cores are included in the subsystem

References XVprocSs::HcrsmplrPtr, XVprocSs::VcrsmplrInPtr, XVprocSs::VcrsmplrOutPtr, XVPROCSS_EVT_CFG_HCR, XVPROCSS_EVT_CFG_VCRI, XVPROCSS_EVT_CFG_VCRO, and XVprocSs_LogWrite().

void XVprocSs_LoadScalerCoeff | ( | XVprocSs * | InstancePtr,
|  | u32 | CoreId,
|  | u16 | num_phases,
|  | u16 | num_taps,
|  | const short * | Coeff
| ) |  |

This function enables user to load external filter coefficients for Scaler cores, independently for H & V.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  CoreId | is the Scaler core to be worked on XVPROCSS_SUBCORE_SCALER_V XVPROCSS_SUBCORE_SCALER_H
  num_phases | is the number of phases supported by Scaler
  num_taps | is the effective taps to be used by Scaler
  Coeff | is the pointer to the filter table to be loaded

Returns
  None

Note
  Applicable only if Scaler cores are included in the subsystem

References XVprocSs::HscalerPtr, XVprocSs::VscalerPtr, XVPROCSS_EVT_CFG_HSCALER, XVPROCSS_EVT_CFG_VSCALER, and XVprocSs_LogWrite().

void XVprocSs_ReportSubcoreStatus | ( | XVprocSs * | InstancePtr,
|  | u32 | SubcoreId
| ) |  |

This function reports the status of specified sub-core.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  SubcoreId | is the subcore index from the below list XVPROCSS_SUBCORE_SCALER_V XVPROCSS_SUBCORE_SCALER_H XVPROCSS_SUBCORE_VDMA XVPROCSS_SUBCORE_LBOX XVPROCSS_SUBCORE_CR_H XVPROCSS_SUBCORE_CR_V_IN XVPROCSS_SUBCORE_CR_V_OUT XVPROCSS_SUBCORE_CSC XVPROCSS_SUBCORE_DEINT

Returns
  None

References XVprocSs::CscPtr, XVprocSs::CtxtData, XVprocSs::DeintPtr, XVprocSs::HcrsmplrPtr, XVprocSs::HscalerPtr, XVprocSs::LboxPtr, XVprocSs_ContextData::PixelWidthInBits, XVprocSs::VcrsmplrInPtr, XVprocSs::VcrsmplrOutPtr, XVprocSs::VscalerPtr, and XVprocSs_VdmaDbgReportStatus().

void XVprocSs_ReportSubsystemConfig | ( | XVprocSs * | InstancePtr | ) |

This function reports the subsystem HW and input/output stream configuration.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.

Returns
  None

References XVprocSs::CtxtData, XVprocSs_ContextData::RtngTable, XVprocSs::VidIn, XVprocSs::VidOut, XVprocSs_GetPipZoomWinHStepSize, XVprocSs_GetZoomPipWindow(), XVprocSs_IsConfigModeMax, XVprocSs_IsPipModeOn, and XVprocSs_IsZoomModeOn.

void XVprocSs_ReportSubsystemCoreInfo | ( | XVprocSs * | InstancePtr | ) |

This function reports Video Processing Subsystem HW configuration.

Parameters

  InstancePtr | is a pointer to the Subsystem instance.

Returns
  None

References XVprocSs_Config::ColorDepth, XVprocSs::Config, XVprocSs::CscPtr, XVprocSs::DeintPtr, XVprocSs::HcrsmplrPtr, XVprocSs::HscalerPtr, XVprocSs::LboxPtr, XVprocSs_Config::MaxHeight, XVprocSs_Config::MaxWidth, XVprocSs_Config::NumVidComponents, XVprocSs_Config::PixPerClock, XVprocSs::RouterPtr, XVprocSs::RstAximmPtr, XVprocSs::RstAxisPtr, XVprocSs::VcrsmplrInPtr, XVprocSs::VcrsmplrOutPtr, XVprocSs::VdmaPtr, XVprocSs::VscalerPtr, and XVprocSs_GetSubsystemTopology.

Referenced by XSys_ReportSystemInfo().

void XVprocSs_Reset | ( | XVprocSs * | InstancePtr | ) |

This function resets the video subsystem sub-cores.

There are 2 reset networks within the subsystem

- For cores that are on AXIS interface
- For cores that are on AXI-MM interface

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.

Returns
  None

XVprocSs_Reset,_Start controls vpss resets as shown axis_int -—_______________________-----------------------------— axis_ext -—________________________________________________----— aximm --------—_______--------------------------------------— | 100us| 100us| 1000us | 1000us | | _Reset...............................| | Program VSPP IP| _Start

References XVprocSs::CtxtData, XVprocSs::RstAximmPtr, XVprocSs::RstAxisPtr, XVprocSs_ContextData::StartCore, XVPROCSS_EDAT_SUCCESS, XVPROCSS_EVT_RESET_VPSS, XVprocSs_LogWrite(), XVPROCSS_RSTMASK_IP_AXIMM, XVPROCSS_RSTMASK_IP_AXIS, and XVprocSs_VdmaReset().

Referenced by XVprocSs_CfgInitialize().

void XVprocSs_SetFrameBufBaseaddr | ( | XVprocSs * | InstancePtr,
|  | UINTPTR | addr
| ) |  |

This function sets the base address of the video frame buffers used by the subsystem instance.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  addr | is the base address of the video frame buffers

Returns
  None

References XVprocSs::FrameBufBaseaddr.

Referenced by XSys_Init().

void XVprocSs_SetPictureBrightness | ( | XVprocSs * | InstancePtr,
|  | s32 | NewValue
| ) |  |

This function updates picture brighntess setting with specified value.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  NewValue | is the new value to be written Range: 0-100

Returns
  None

Note
  Applicable only if CSC core is included in the subsystem

References XVprocSs::CscPtr.

void XVprocSs_SetPictureColorRange | ( | XVprocSs * | InstancePtr,
|  | XVidC_ColorRange | NewVal
| ) |  |

This function sets picture color range for output.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  NewVal | is the required color range XVIDC_CR_16_235 XVIDC_CR_16_240

- XVIDC_CR_0_255

Returns
  None

Note
  Applicable only if CSC core is included in the subsystem

References XVprocSs::CscPtr.

void XVprocSs_SetPictureColorStdIn | ( | XVprocSs * | InstancePtr,
|  | XVidC_ColorStd | NewVal
| ) |  |

This function sets picture color standard setting for input.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  NewVal | is the required color standard XVIDC_BT_2020 XVIDC_BT_709 XVIDC_BT_601

Returns
  None

Note
  Applicable only if CSC core is included in the subsystem

References XVprocSs::CscPtr.

void XVprocSs_SetPictureColorStdOut | ( | XVprocSs * | InstancePtr,
|  | XVidC_ColorStd | NewVal
| ) |  |

This function sets picture color standard setting for output.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  NewVal | is the required color standard XVIDC_BT_2020 XVIDC_BT_709 XVIDC_BT_601

Returns
  None

Note
  Applicable only if CSC core is included in the subsystem

References XVprocSs::CscPtr.

void XVprocSs_SetPictureContrast | ( | XVprocSs * | InstancePtr,
|  | s32 | NewValue
| ) |  |

This function updates picture contrast setting with specified value.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  NewValue | is the new value to be written Range: 0-100

Returns
  None

Note
  Applicable only if CSC core is included in the subsystem

References XVprocSs::CscPtr.

int XVprocSs_SetPictureDemoWindow | ( | XVprocSs * | InstancePtr,
|  | XVidC_VideoWindow * | Win
| ) |  |

This function sets picture Demo Window.

Post this function call all further picture settings will apply only within the defined window. Demo window gets reset everytime subsystem configuration changes

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  Win | is the pointer to window coordinates within which picture settings should be applied

Returns
  XST_SUCCESS if window is valid else XST_FAILURE

Note
  Applicable only if CSC core is included in the subsystem and the Demo Window is enabled

References XVprocSs::CscPtr, XVPROCSS_EVT_CFG_CSC, and XVprocSs_LogWrite().

void XVprocSs_SetPictureGain | ( | XVprocSs * | InstancePtr,
|  | XVprocSs_ColorChannel | ChId,
|  | s32 | NewValue
| ) |  |

This function updates picture gain setting with specified value.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  ChId | is the color channel id for which gain is to be updated
  NewValue | is the new value to be written Range: 0-100

Returns
  none

Note
  Applicable only if CSC core is included in the subsystem

References XVprocSs::CscPtr.

void XVprocSs_SetPictureSaturation | ( | XVprocSs * | InstancePtr,
|  | s32 | NewValue
| ) |  |

This function updates picture saturation setting with specified value.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  NewValue | is the new value to be written Range: 0-100

Returns
  None

Note
  Applicable only if CSC core is included in the subsystem

References XVprocSs::CscPtr.

void XVprocSs_SetPIPBackgroundColor | ( | XVprocSs * | InstancePtr,
|  | XLboxColorId | ColorId
| ) |  |

This function sets PIP background color.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  ColorIs | is the requested background color XLBOX_BKGND_BLACK XLBOX_BKGND_WHITE XLBOX_BKGND_RED XLBOX_BKGND_GREEN XLBOX_BKGND_BLUE

Returns
  None

Note
  Applicable only if Letterbox core is included in the subsystem

References XVprocSs::CtxtData, XVprocSs_ContextData::LboxBkgndColor, XVprocSs::LboxPtr, XVprocSs_ContextData::StrmCformat, XVprocSs::VidIn, XVPROCSS_EVT_SET_PIPMODE, and XVprocSs_LogWrite().

void XVprocSs_SetPipMode | ( | XVprocSs * | InstancePtr,
|  | u8 | OnOff
| ) |  |

This function configures the video subsystem to enable/disable PIP feature If PIP mode is set to ON but user has not set window coordinates then half of input stream resolution at coordinates 0,0 is set as the default zoom window.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  OnOff | is the action required

Returns
  None

Note
  User must call XVprocSs_ConfigureSubsystem() for change to take effect This call has not been added here such that it provides an opportunity to make the change during vertical blanking at system level. This behavior will change once shadow register support is available in sub-core IP's This function is not applicable in Subsystem Stream Mode Configuration

References XVprocSs::CtxtData, XVprocSs_ContextData::PipEn, XVPROCSS_EVT_SET_PIPMODE, XVprocSs_IsConfigModeMax, XVprocSs_LogWrite(), and XVprocSs_ContextData::ZoomEn.

int XVprocSs_SetStreamResolution | ( | XVidC_VideoStream * | StreamPtr,
|  | const XVidC_VideoMode | VmId,
|  | XVidC_VideoTiming const * | Timing
| ) |  |

This function sets the required subsystem video stream to the user provided stream and timing parameters.

Parameters

  StreamPtr | is a pointer to the subsystem video stream to be configured
  VmId | is the Video Mode ID of the new resolution to be set
  Timing | is the timing parameters of the new resolution to be set

Returns
  XST_SUCCESS if successful else XST_FAILURE

int XVprocSs_SetSubsystemConfig | ( | XVprocSs * | InstancePtr | ) |

This function is the entry point into the video processing subsystem driver processing path.

It will examine the instantiated subsystem configuration mode and the input and output stream configuration. Based on the available information control flow is determined and requisite sub-cores are configured to implement the supported use case

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.

Returns
  XST_SUCCESS if successful else XST_FAILURE

References XVPROCSS_EVT_CHK_TOPO, XVprocSs_GetSubsystemTopology, and XVprocSs_LogWrite().

void XVprocSs_SetUserTimerHandler | ( | XVprocSs * | InstancePtr,
|  | XVidC_DelayHandler | CallbackFunc,
|  | void * | CallbackRef
| ) |  |

This function registers the user defined delay/sleep function with subsystem.

Parameters

  InstancePtr | is a pointer to the Subsystem instance
  CallbackFunc | is the function pointer to the user defined delay function
  CallbackRef | is the pointer to timer instance used by the delay function

Returns
  None

References XVprocSs::UsrDelayUs, and XVprocSs::UsrTmrPtr.

int XVprocSs_SetVidStreamIn | ( | XVprocSs * | InstancePtr,
|  | const XVidC_VideoStream * | StrmIn
| ) |  |

This function configures the video subsystem input interface.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  StrmIn | is the pointer to input stream configuration

Returns
  XST_SUCCESS

References XVprocSs::VidIn.

Referenced by XSys_SetStreamParam().

int XVprocSs_SetVidStreamOut | ( | XVprocSs * | InstancePtr,
|  | const XVidC_VideoStream * | StrmOut
| ) |  |

This function configures the video subsystem output interface.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  StrmOut | is the pointer to input stream configuration

Returns
  XST_SUCCESS

References XVprocSs::VidOut.

Referenced by XSys_SetStreamParam().

void XVprocSs_SetZoomMode | ( | XVprocSs * | InstancePtr,
|  | u8 | OnOff
| ) |  |

This function configures the video subsystem to enable/disable ZOOM feature If ZOOM mode is set to ON but user has not set window coordinates then quarter of input stream resolution at coordinates 0,0 is set as the default zoom window.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  OnOff | is the action required

Returns
  None

Note
  User must call XVprocSs_ConfigureSubsystem() for change to take effect This call has not been added here such that it provides an opportunity to make the change during vertical blanking at system level. This behavior will change once shadow register support is available in sub-core IP's This function is not applicable in Subsystem Stream Mode Configuration

References XVprocSs::CtxtData, XVprocSs_ContextData::PipEn, XVPROCSS_EVT_SET_ZOOMMODE, XVprocSs_IsConfigModeMax, XVprocSs_LogWrite(), and XVprocSs_ContextData::ZoomEn.

void XVprocSs_SetZoomPipWindow | ( | XVprocSs * | InstancePtr,
|  | XVprocSs_Win | mode,
|  | XVidC_VideoWindow * | win
| ) |  |

This function allows user to set the Zoom or PIP window.

Scratch pad memory is updated with the new window information

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.
  mode | is feature to be updated PIP or ZOOM
  win | is structure that contains window coordinates and size

Returns
  None

Note
  For Zoom mode RD client window is written in scratch pad memory For Pip mode WR client window is written in scratch pad memory This function is not applicable in Subsystem Stream Mode Configuration

References XVprocSs::Config, XVprocSs::CtxtData, XVprocSs_ContextData::PixelHStepSize, XVprocSs_Config::PixPerClock, XVprocSs_ContextData::RdWindow, XVprocSs::VdmaPtr, XVprocSs_ContextData::WrWindow, XVPROCSS_EDAT_SUCCESS, XVPROCSS_EVT_SET_PIPWIN, XVPROCSS_EVT_SET_ZOOMWIN, XVprocSs_IsConfigModeMax, and XVprocSs_LogWrite().

void XVprocSs_Start | ( | XVprocSs * | InstancePtr | ) |

This function starts the video subsystem including all sub-cores that are included in the processing pipeline for a given use-case.

Video pipe is started from back to front

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.

Returns
  None

Note
  Cores are started only if the corresponding start flag in the scratch pad memory is set. This allows to selectively start only those cores included in the processing chain

References XVprocSs::CscPtr, XVprocSs::CtxtData, XVprocSs::DeintPtr, XVprocSs::HcrsmplrPtr, XVprocSs::HscalerPtr, XVprocSs::LboxPtr, XVprocSs::RstAxisPtr, XVprocSs_ContextData::StartCore, XVprocSs::VcrsmplrInPtr, XVprocSs::VcrsmplrOutPtr, XVprocSs::VscalerPtr, XVPROCSS_EDAT_SUCCESS, XVPROCSS_EVT_START_VPSS, XVprocSs_LogWrite(), XVPROCSS_RSTMASK_VIDEO_IN, and XVprocSs_VdmaStartTransfer().

Referenced by XVprocSs_SetupRouterDataFlow().

void XVprocSs_Stop | ( | XVprocSs * | InstancePtr | ) |

This function stops the video subsystem including all sub-cores Stop the video pipe starting from front to back.

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.

Returns
  None

References XVprocSs::CscPtr, XVprocSs::DeintPtr, XVprocSs::HcrsmplrPtr, XVprocSs::HscalerPtr, XVprocSs::LboxPtr, XVprocSs::VcrsmplrInPtr, XVprocSs::VcrsmplrOutPtr, XVprocSs::VdmaPtr, XVprocSs::VscalerPtr, XVPROCSS_EDAT_SUCCESS, XVPROCSS_EVT_STOP_VPSS, XVprocSs_LogWrite(), and XVprocSs_VdmaStop().

void XVprocSs_UpdateZoomPipWindow | ( | XVprocSs * | InstancePtr | ) |

This function updates the Pip/Zoom window currently on screen in-place.

This implies the video is not blanked and the new coordinates will update instantly as the function executes

Parameters

  InstancePtr | is a pointer to the Subsystem instance to be worked on.

Returns
  None

Note
  This function must be called only after the respective mode (PIP/Zoom) has been enabled and user wants to move window to a new location This function is not applicable in Subsystem Stream Mode Configuration

References XVprocSs::CtxtData, XVprocSs::LboxPtr, XVprocSs::VidOut, XVprocSs_ContextData::WrWindow, XVPROCSS_EDAT_SUCCESS, XVPROCSS_EVT_UPDATE_ZPWIN, XVprocSs_IsConfigModeMax, XVprocSs_IsPipModeOn, XVprocSs_LogWrite(), XVprocSs_VdmaSetWinToDnScaleMode(), XVprocSs_VdmaSetWinToUpScaleMode(), and XVprocSs_VdmaStartTransfer().